/* ------------------------------ Tests ------------------------------ */
var sys = require("sys");

Function.prototype.bind = function(context) {
  if (arguments.length < 2 && typeof arguments[0] === "undefined") return this;
  var __method = this, args = Array.prototype.slice.call(arguments, 1);
  return function() {
    var a = Array.prototype.slice.call(args, 0),
        arrayLength = a.length,
        length = arguments.length;
    
    while (length--) a[arrayLength + length] = arguments[length];
        
    return __method.apply(context, a);
  }
};

require.paths.unshift(process.cwd());
process.mixin(GLOBAL, require('lib/irc'));

var server = require('spec/server').server,
    s = new server();
s.run();

process.addListener("data", function() {
  s.close();
});
process.openStdin();

/* ------------------------------ TESTS ------------------------------ */
describe("IRC", function () {

  var irc = new IRC({port: 7666});
  irc.connect();
  
  // before(function() {
  //   irc.connect();
  // });
  
  it("should be able to set a nickname", function() {
    irc.nick("roger");
    // "5".shouldEqual("6");
    setTimeout(function() {
      sys.puts(sys.inspect(s.received));
      "5".shouldEqual("6");
    }.bind(this), 150);
  });

  // it("should supply a nick and user", function () {
  //   irc.connect(function() {
  //     setTimeout(function() {
  //       sys.puts(sys.inspect(s.received));
  //       s.received[0].shouldEqual("NICK " + irc.options.nick);
  //       s.received[1].shouldEqual("USER " + [irc.options.user.username, irc.options.user.hostname, irc.options.user.servername, ':' + irc.options.user.realname].join(' '));
  //       irc.disconnect();
  //     }.bind(this), 150);
  //   });
  // });

});
