var tcp = require("net"),
    sys = require("sys");

function DummyServer(o) {
  var options = process.mixin({ port: 7666 }, o || {}),
      _self = this,
      server = tcp.createServer(function (socket) {
        socket.setEncoding("utf8");
        
        socket.addListener("receive", function (data) {
          data.split(/\r\n/).forEach(function(line){
            if (line) _self.received.push(line);
          })
        });
        
        socket.addListener("eof", function () {
          socket.close();
        });
        
        _self.send = function(data) {
          socket.send(data);
        };
      });
  
  this.run = function() {
    server.listen(options.port, "localhost");
  };
  
  this.close = function() {
    server.close();
    process.exit();
  };
  
  this.received = [];
}

exports.server = DummyServer;
